version: "2.4"
services:
  frontend:
    image: node:alpine
    depends_on:
      - backend
    links:
      - backend
    restart: always
    expose:
      - 5000
      - 35729
    ports:
      - "5000:5000"
      - "35729:35729"
    container_name: "vision-prototype-svelte"
    working_dir: /app
    volumes:
      - ./frontend:/app
    command: /bin/sh -c "npm install && npm run dev"
  backend:
    depends_on:
      - db
    links:
      - db
    environment:
      - FLASK_ENV=development
      - FLASK_RUN_PORT=8000
      - DATABASE_URL=postgres://postgres@db:5432/postgres
    build:
      context: ./app
      dockerfile: ./dev.Dockerfile
    restart: always
    ports:
      - "8000:8000"
    container_name: "vision-prototype-flask"
    volumes:
      - ./app:/usr/src/app

  processing:
    container_name: vision-prototype-processing
    environment:
      - DATABASE_URL=postgres://postgres@db:5432/postgres
      - CROPPER_HOST=10.0.40.126
      - BATCH_SIZE=10
    build:
      context: ./backend
      dockerfile: ./processing.Dockerfile
    depends_on:
      - db
    links:
      - db
    restart: always
  db:
    image: postgres:12.1-alpine
    restart: always
    container_name: "vision-prototype-postgres"
    environment:
      - POSTGRES_HOST=127.0.0.1
    ports:
      - "5432:5432"
    volumes:
      - ~/Dev/data/vision-service:/var/lib/postgresql/data
  spaser:
    container_name: vision-prototype-spaser
    environment:
      - DATABASE_URL=postgres://postgres@db:5432/postgres
    build:
      context: ./backend
      dockerfile: ./spaser.Dockerfile
    depends_on:
      - db
    links:
      - db
    restart: always